-- backoffice database replicated to NSP-nodes
CREATE DATABASE sts_audconf;

USE sts_audconf;


DROP TABLE IF EXISTS audienceConfiguration;
CREATE TABLE audienceConfiguration (
   audience VARCHAR(255) NOT NULL,
   attribute VARCHAR(50) NOT NULL,
   attribute_value VARCHAR(4095));
CREATE UNIQUE INDEX audienceConfiguration_uniq ON audienceConfiguration (audience, attribute);


DROP TABLE IF EXISTS iboConfig;
CREATE TABLE iboConfig (
  audience VARCHAR(255) NOT NULL,
  publicKey TEXT NOT NULL,
  recipientURL VARCHAR(255) NOT NULL,
  includeBST BOOL NOT NULL,
  deliveryNotOnOrAfterOffset BIGINT NOT NULL,
  notBeforeOffset BIGINT NOT NULL,
  notOnOrAfterOffset BIGINT NOT NULL,
  idCardMaxAgeMins BIGINT,
  KEY audience (audience)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

GRANT ALL ON sts_audconf.* TO 'sts'@'%';

