-- local database - not replicated
CREATE DATABASE sts;

USE sts;

-- Only one of cprhash and cprcache will be used depending on config
-- Having both will be harmless
DROP TABLE IF EXISTS cprhash;
CREATE TABLE cprhash (
	hash CHAR(46) NOT NULL,
	createdDate datetime);
CREATE UNIQUE INDEX cpr_hash ON cprhash (hash);

DROP TABLE IF EXISTS cprcache;
CREATE TABLE cprcache (
	ssn VARCHAR(64) NOT NULL,
	cpr VARCHAR(16) NOT NULL,
	createdDate datetime);
CREATE UNIQUE INDEX cprcache_ssn ON cprcache (ssn);

DROP TABLE IF EXISTS whitelist;
CREATE TABLE whitelist (
	ssn VARCHAR(255) NOT NULL,
	created datetime);
CREATE UNIQUE INDEX whitelist_ssn ON whitelist (ssn);

DROP TABLE IF EXISTS blacklist;
CREATE TABLE blacklist (
	ssn VARCHAR(255) NOT NULL,
	created datetime);
CREATE UNIQUE INDEX blacklist_ssn ON blacklist (ssn);

GRANT ALL ON sts.* TO 'sts'@'%';
