package dk.sosi.sts.fuldmagt.stub;

import dk.sosi.sts.fuldmagt.*;

import javax.jws.WebMethod;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.JAXBElement;
import javax.xml.namespace.QName;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;
import java.util.List;

@WebService(name = "IQueryWebService", serviceName = "MockService2", targetNamespace = "https://DelegationQuery.Nemlog-in.dk/")
public class ProcurationServiceStub2 implements IQueryWebService {

    public static final String NAMESPACE_URI = "http://schemas.datacontract.org/2004/07/DK.OES.KFOBS.Delegation.Frontend.DelegationWebService";

    @Override
    @WebMethod(operationName = "GetDelegations", action = "https://DelegationQuery.Nemlog-in.dk/IQueryWebService/GetDelegations")
    @WebResult(name = "GetDelegationsResult", targetNamespace = "https://DelegationQuery.Nemlog-in.dk/")
    @RequestWrapper(localName = "GetDelegations", targetNamespace = "https://DelegationQuery.Nemlog-in.dk/", className = "dk.sosi.sts.fuldmagt.GetDelegations")
    @ResponseWrapper(localName = "GetDelegationsResponse", targetNamespace = "https://DelegationQuery.Nemlog-in.dk/", className = "dk.sosi.sts.fuldmagt.GetDelegationsResponse")
    public DelegationResponse getDelegations(String entityId, RepresentativeId representativeId) {
        final String representativeCPR = representativeId.getCPR().getValue();
        System.out.println("Representative CPR:  " + representativeCPR);
        DelegationResponse response = new DelegationResponse();
        response.setResponseId(new JAXBElement<>(new QName(NAMESPACE_URI, "ResponseId"), String.class, representativeCPR));
        ArrayOfDelegation delegations = new ArrayOfDelegation();
        List<Procuration> procurationList = ProcurationTestModel.getProcurations2(representativeCPR);

        for (Procuration procuration : procurationList) {
            Delegation delegation = new Delegation();
            delegation.setCitizenCpr(new JAXBElement<>(new QName(NAMESPACE_URI, "CitizenCpr"), String.class, procuration.fromCpr));
            PrivilegeList privilegeList = new PrivilegeList();
            privilegeList.getString().addAll(procuration.privileges);
            delegation.setPrivileges(new JAXBElement<>(new QName(NAMESPACE_URI, "Privileges"), PrivilegeList.class, privilegeList));
            delegations.getDelegation().add(delegation);
        }

        response.setDelegations(new JAXBElement<>(new QName(NAMESPACE_URI, "Delegations"), ArrayOfDelegation.class, delegations));
        return response;
    }

    @Override
    public DelegationResponse getCompanyDelegations(String entityId, CompanyRepresentationId companyRepresentationId, Filter filter) {
        throw new UnsupportedOperationException("Not implemented");
    }

    @Override
    public DelegationResponse getDelegationsCreatedByCitizen(String entityId, Citizen citizenId) {
        throw new UnsupportedOperationException("Not implemented");
    }

    @Override
    public DelegationResponse getAllCreatedDelegationsAssignedToItSystem(String entityId, String privilegeUri, Integer offset) {
        throw new UnsupportedOperationException("Not implemented");
    }
}
