package dk.sosi.sts.fuldmagt.stub;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class ProcurationTestModel {
    public static final String FMK_READ = "urn:dk:nspop:sts:fmk:read";
    public static final String FMK_WRITE = "urn:dk:nspop:sts:fmk:write";
    public static final String PRIVILEGE_1 = "mock:privilege:1";
    public static final String PRIVILEGE_2 = "mock:privilege:2";

    public static final String CPR_1 = "1111111118";
    public static final String CPR_2 = "0101603040";
    public static final String CPR_3 = "0501792275";
    public static final String CPR_4 = "1111111119";

    public static List<Procuration> getProcurations1(String toCpr) {
        List<Procuration> procurations = new ArrayList<>();
        procurations.add(new Procuration(CPR_1, CPR_3, FMK_READ));
        procurations.add(new Procuration(CPR_2, CPR_3, FMK_WRITE));
        return procurations.stream()
                .filter(procuration -> procuration.toCpr.equals(toCpr))
                .collect(Collectors.toList());
    }

    public static List<Procuration> getProcurations2(String toCpr) {
        List<Procuration> procurations = new ArrayList<>();
        procurations.add(new Procuration(CPR_1, CPR_3, PRIVILEGE_1));
        procurations.add(new Procuration(CPR_2, CPR_3, PRIVILEGE_2));
        return procurations.stream()
                .filter(procuration -> procuration.toCpr.equals(toCpr))
                .collect(Collectors.toList());
    }

}
