package dk.sosi.sts.idp;

import dk.sosi.sts.model.Configuration;
import dk.sosi.sts.model.IdpConfig;

import java.util.List;
import java.util.Properties;
import java.util.stream.Collectors;

public class IdpConfigImpl implements IdpConfig {
	protected String issuer;
	protected Configuration configuration;
	
	public IdpConfigImpl(String issuer, Configuration conf) {
		this.issuer = issuer;
		this.configuration = conf;
	}

	@Override
	public String getIssuer() {
		return issuer;
	}

	@Override
	public String getAudience() {
		return configuration.get("audience");
	}

	@Override
	public List<String> getSigningKeys() {
		List<String> list = configuration.startsWith("signingKey");
		return list;
	}

	@Override
	public List<String> getEncryptionKeys() {
		return configuration.startsWith("encryptionKey");
	}

	@Override
	public String getValidateHOK() {
		return configuration.get("validateHOK");
	}

	@Override
	public List<String> getTokenProfiles() {
		return configuration.startsWith("tokenProfile");
	}

	@Override
	public List<String> getCertificates() {
		return configuration.startsWith("certificate");
	}

}
