package dk.sosi.sts.integrations.personinformation;

public class Custody {
    public static Custody fromValues(String type, String cpr) {
        return new Custody(
            CustodyType.valueOf(type.toUpperCase()), cpr
        );
    }

    // Typerne her matcher navnene på de typer man får fra "personinformation".
    public enum CustodyType {
        PARENTALCUSTODY,
        WARDCUSTODY
    }

    private final String relationCpr;
    private final CustodyType custodyType;

    public Custody(CustodyType custodyType, String relationCpr) {
        this.relationCpr = relationCpr;
        this.custodyType = custodyType;
    }

    public String getRelationCpr() {
        return relationCpr;
    }

    public CustodyType getCustodyType() {
        return custodyType;
    }

    public boolean equals(Object o) {
        if (o == this) return true;
        if (!(o instanceof Custody)) return false;
        final Custody other = (Custody) o;
        return other.getCustodyType().equals(this.getCustodyType()) && other.getRelationCpr().equals(this.getRelationCpr());
    }

    public int hashCode() {
        return this.getCustodyType().hashCode() + this.getRelationCpr().hashCode();
    }
}
