package dk.sosi.sts.integrations.personinformation;

import org.junit.Test;

import static org.junit.Assert.*;

public class CustodyTest {
    @Test
    public void testFromValues() {
        Custody custody = Custody.fromValues("parentalcustody", "1234567890");
        assertEquals(Custody.CustodyType.PARENTALCUSTODY, custody.getCustodyType());
        assertEquals("1234567890", custody.getRelationCpr());
    }

    @Test
    public void testEquals() {
        Custody custody1 = new Custody(Custody.CustodyType.PARENTALCUSTODY, "1234567890");
        Custody custody2 = new Custody(Custody.CustodyType.PARENTALCUSTODY, "1234567890");
        assertEquals(custody1, custody2);
    }

    @Test
    public void testHashEquals() {
        Custody custody1 = new Custody(Custody.CustodyType.PARENTALCUSTODY, "1234567890");
        Custody custody2 = new Custody(Custody.CustodyType.PARENTALCUSTODY, "1234567890");
        assertEquals(custody1.hashCode(), custody2.hashCode());
    }

    @Test
    public void testNotEquals() {
        Custody custody1 = new Custody(Custody.CustodyType.PARENTALCUSTODY, "1234567890");
        Custody custody2 = new Custody(Custody.CustodyType.WARDCUSTODY, "1234567890");
        assertNotEquals(custody1, custody2);
    }
}
