package dk.sosi.sts.integrations.personinformation;

import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.entity.BasicHttpEntity;
import org.apache.http.message.BasicHttpResponse;
import org.mockito.Mockito;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Proxy;
import java.nio.charset.StandardCharsets;

public class TestUtil {
    public static HttpResponse createHttpResponse(int statusCode, String contentType, String body) {
        StatusLine statusLine = Mockito.mock(StatusLine.class);
        Mockito.when(statusLine.getStatusCode()).thenReturn(statusCode);
        BasicHttpResponse httpResponse = new BasicHttpResponse(statusLine);
        BasicHttpEntity httpEntity = new BasicHttpEntity();
        httpEntity.setContent(inputStreamFromString(body));
        httpResponse.setEntity(httpEntity);
        httpResponse.setHeader("Content-Type", contentType);

        return (HttpResponse) Proxy.newProxyInstance(CloseableHttpResponse.class.getClassLoader(),
                new Class[] { CloseableHttpResponse.class },
                (proxy, method, args) -> {
                    if (method.getName().equals("close")) {
                        return null;
                    }
                    return method.invoke(httpResponse, args);
                });
    }

    private static InputStream inputStreamFromString(String input) {
        return new ByteArrayInputStream(input.getBytes(StandardCharsets.UTF_8));
    }
}
