package dk.sosi.sts.ridcpr.stub;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;
import java.util.Optional;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class RidCpr extends HttpServlet {
	private static final long serialVersionUID = 1L;

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		List<String> lines = readRidMapping();

		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();

			Document document = builder.parse(new InputSource(req.getInputStream()));

			XPath xPath = XPathFactory.newInstance().newXPath();

			String value = xPath.evaluate("//Envelope/Body/getCPR/string/text()", document);
			System.out.println(value);
			PrintWriter writer = resp.getWriter();
			resp.setContentType("text/xml");

			Optional<String> cpr = lines.stream().filter(x -> x.split("@")[0].equals(value)).findFirst();
			String response = null;
			if (cpr.isPresent()) {
				response = responseTemplate.replace("@CPR@", cpr.get().split("@")[1]);
			}
			else {
				response = nullResponse;
			}

			System.out.println(response);
			writer.println(response);
			return;
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (XPathExpressionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		resp.setStatus(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
	}

	private List<String> readRidMapping() throws IOException {
		String fileName = System.getenv("RID_MAPPING");
		if (fileName == null) {
			fileName = System.getProperty("java.io.tmpdir") + "/rid_mapping.txt";
		}
		
		return Files.readAllLines(Paths.get(fileName));
	}

	private String nullResponse = "<soapenv:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:loc=\"http://localhost/\">\n" + 
			"   <soapenv:Header/>\n" + 
			"   <soapenv:Body>\n" + 
			"      <loc:getCPRResponse soapenv:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">\n" + 
			"      </loc:getCPRResponse>\n" + 
			"   </soapenv:Body>\n" + 
			"</soapenv:Envelope>";
	
	private String responseTemplate = "<soapenv:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:loc=\"http://localhost/\">\n"
			+ "   <soapenv:Header/>\n" + "   <soapenv:Body>\n"
			+ "      <loc:getCPRResponse soapenv:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">\n"
			+ "         <result xsi:type=\"xsd:string\">@CPR@</result>\n" + "      </loc:getCPRResponse>\n"
			+ "   </soapenv:Body>\n" + "</soapenv:Envelope>";
}
