package dk.sosi.sts.model;

import dk.sosi.seal.model.BasicPrivileges;

import java.util.ArrayList;
import java.util.List;

public class PrivilegeGroup {
    private final String scope;
    private final List<String> privileges = new ArrayList<>();
    private final List<BasicPrivileges.Constraint> constraints = new ArrayList<>();

    public PrivilegeGroup(String scope) {
        this.scope = scope;
    }

    public void addPrivilege(String privilege) {
        privileges.add(privilege);
    }

    public void addConstraint(String name, String value) {
        constraints.add(new BasicPrivileges.Constraint(name, value));
    }

    public String getScope() {
        return scope;
    }

    public List<String> getPrivileges() {
        return privileges;
    }

    public List<BasicPrivileges.Constraint> getConstraints() {
        return constraints;
    }
}
