/*
 * The MIT License
 *
 * Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *
 * Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */
package dk.sosi.sts.sla;

public enum SLALogPoint {
	STSFACADE_REQUEST("200", "AbstractStsRequestHandler.request"),
	STS_ISSUEIDCARD("210", "SecurityTokenService.issueIdCard"),
	CVRRID_FINDRELATED("220", "WsOcesCvrRidService.findRelatedCpr"),
	PID_CHECKRELATED("221", "WsOcesPidService.isRelated"),
	FULDMAGT_GETDELEGATIONS("222", "ProcurationWebService.getProcurationPrivileges"),
	ITS_SERIALIZE("230", "IdentityTokenService.serialize"),
	CRL_LOAD("240", "StsOcesCrlServiceImpl.load"),
	NBO_SERIALIZE("250", "NboRequestHandler.serialize"),
	SIGN("260", "SignatureProvider.sign"),
	NBO_IDWS("270", "NboIdwsRequestHandler.convert"),
	BST2SOSI_SERIALIZE("280","BST2SOSIRequestHandler.convert"),
	UUID2CPRPROXY_FIND_CPR_FROM_UUID("290", "UUID2CPRPROXY.lookupCprByUuid"),
	UUID2CPRPROXY_FIND_CPR_FROM_PID("300", "UUID2CPRPROXY.lookupCprByPid"),
	UUID2CPRPROXY_FIND_RID_FROM_UUID("310", "UUID2CPRPROXY.lookupRidByUuid");


	private final String id;
	private final String name;

	SLALogPoint(String id, String name) {
		this.id = id;
		this.name = name;
	}
	
	public String getId() {
		return id;
	}
	
	public String getName() {
		return name;
	}
}
