/*
 * The MIT License
 *
 * Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *
 * Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */
package dk.sosi.sts.model;

import junit.framework.TestCase;

import static org.junit.Assert.assertNotEquals;

public class SubjectSerialNumberTest extends TestCase {
	
	final static String SSN = "SSN";
	
	public void testGetValue() {
		SubjectSerialNumber ssn = new SubjectSerialNumber(SSN);
		assertEquals(SSN, ssn.getValue());
	}
	
	public void testHashCode() {
		SubjectSerialNumber ssn = new SubjectSerialNumber(null);
		ssn.hashCode();
		ssn = new SubjectSerialNumber(SSN);
		ssn.hashCode();
	}
	
	public void testEquals() {
		SubjectSerialNumber ssn1 = new SubjectSerialNumber(SSN);
		assertEquals(ssn1, ssn1);

		assertNotEquals(null, ssn1);

		assertNotEquals(ssn1, new Object());

		SubjectSerialNumber ssn2 = new SubjectSerialNumber(SSN);
		assertEquals(ssn1, ssn2);

		ssn2 = new SubjectSerialNumber("test");
		assertNotEquals(ssn1, ssn2);
	}
	
	public void testToString() {
		SubjectSerialNumber ssn = new SubjectSerialNumber(SSN);
		
		assertTrue(ssn.toString().contains(SSN));
	}
}
