-- backoffice database replicated to NSP-nodes
CREATE SCHEMA sts_audconf;

DROP TABLE IF EXISTS sts_audconf.audienceConfiguration;
CREATE TABLE sts_audconf.audienceConfiguration (
   audience VARCHAR(255) NOT NULL,
   attribute VARCHAR(50) NOT NULL,
   attribute_value VARCHAR(4095));
CREATE UNIQUE INDEX audienceConfiguration_uniq ON sts_audconf.audienceConfiguration (audience, attribute);
GRANT ALL ON sts_audconf.audienceConfiguration TO sts;

DROP TABLE IF EXISTS sts_audconf.trustedIdpConfiguration;
CREATE TABLE sts_audconf.trustedIdpConfiguration (
   issuer VARCHAR(255) NOT NULL,
   attribute VARCHAR(50) NOT NULL,
   attribute_value VARCHAR(4095));
CREATE UNIQUE INDEX trustedIdpConfiguration_uniq ON sts_audconf.trustedIdpConfiguration (issuer, attribute);
GRANT ALL ON sts_audconf.trustedIdpConfiguration TO sts;

DROP TABLE IF EXISTS sts_audconf.iboConfig;
CREATE TABLE sts_audconf.iboConfig (
  audience VARCHAR(255) NOT NULL PRIMARY KEY,
  publicKey TEXT NOT NULL,
  recipientURL VARCHAR(255) NOT NULL,
  includeBST BOOLEAN NOT NULL,
  deliveryNotOnOrAfterOffset BIGINT NOT NULL,
  notBeforeOffset BIGINT NOT NULL,
  notOnOrAfterOffset BIGINT NOT NULL,
  idCardMaxAgeMins BIGINT,
)
GRANT ALL ON sts_audconf.iboConfig TO sts;

