package dk.sosi.sts.monitor;

import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;
import java.util.List;
import java.util.stream.Collectors;

public class AlarmServlet implements Controller {

    private final List<Check> checks;

    public AlarmServlet(List<Check> checks) { this.checks = checks; }

    @Override
    public ModelAndView handleRequest(HttpServletRequest httpServletRequest, HttpServletResponse resp)
            throws Exception {
        List<Check.CheckResult> failedChecks = this.checks.stream().map(Check::performCheck).filter(c -> c.failed)
                .collect(Collectors.toList());
        resp.setContentType("text/plain;charset=utf-8");
        resp.setStatus(failedChecks.isEmpty() ? 200 : 500);
        PrintWriter writer = resp.getWriter();
        failedChecks.forEach(cr -> cr.result.forEach((key, value) -> writer.print(key + ": " + value + "\n")));
        if(failedChecks.isEmpty()) writer.print("No alarms\n");
        writer.print("EOS\n");
        return null;
    }
}