/*
 * The MIT License
 *
 * Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *
 * Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */
package dk.sosi.sts.server;

import dk.sosi.seal.vault.CredentialVault;
import dk.sosi.sts.TrustedVaultProvider;

import java.util.List;

/**
 *
 */
public class NboConfig implements TrustedVaultProvider {
	private long fuzzyTime;
	private long allowedDriftInSeconds;
	private long idCardDuration;
	private CredentialVault trustedVault;
	private List<String> cprTrustCertificates;

	public long getFuzzyTime() {
		return fuzzyTime;
	}

	public void setFuzzyTime(final long fuzzyTime) {
		this.fuzzyTime = fuzzyTime;
	}

	public long getIdCardDuration() {
		return idCardDuration;
	}

	public void setIdCardDuration(final long idCardDuration) {
		this.idCardDuration = idCardDuration;
	}

	@Override
	public CredentialVault getTrustedVault() {
		return trustedVault;
	}

	public void setTrustedVault(final CredentialVault trustedVault) {
		this.trustedVault = trustedVault;
	}

	public long getAllowedDriftInSeconds() {
		return allowedDriftInSeconds;
	}

	public void setAllowedDriftInSeconds(final long allowedDriftInSeconds) {
		this.allowedDriftInSeconds = allowedDriftInSeconds;
	}

	public boolean isCprTrustedFrom(String ssn) {
		return cprTrustCertificates.contains(ssn);
	}

	public void setCprTrustCertificates(List<String> ssnList) {
		this.cprTrustCertificates = ssnList;
	}

	@Override
	public String toString() {
		return "NboConfig{" +
			   "fuzzyTime=" + fuzzyTime +
			   ", allowedDriftInSeconds=" + allowedDriftInSeconds +
			   ", idCardDuration=" + idCardDuration +
			   ", trustedVault=" + trustedVault +
			   '}';
	}


}
