/*
 * The MIT License
 *
 * Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *
 * Copyright (C) 2011 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */
package dk.sosi.sts.monitor;

import java.io.PrintWriter;
import java.io.StringWriter;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.mockito.Mockito;

import junit.framework.TestCase;

public class MonitorServletTest extends TestCase {

	public void testLogOnce() throws Exception {
		final ServletContext servletContext = Mockito.mock(ServletContext.class);
		final Logger mockedLogger = Mockito.mock(Logger.class);

		// We trigger a NPE
		final MonitorServlet monitorServlet = new MonitorServlet(new Check[] { null }) {
			{ log = mockedLogger; }
		};

		final HttpServletRequest req = null;
		final HttpServletResponse resp = Mockito.mock(HttpServletResponse.class);
		Mockito.when(resp.getWriter()).thenReturn(new PrintWriter(new StringWriter()));

		// The loop makes sure that the stack trace stays the same across invocations
		for (int i = 0; i < 10; i++) {
			monitorServlet.doGet(req, resp);
			if (i == 0) {
				Mockito.verify(mockedLogger).error(Mockito.any(), Mockito.<Throwable>any());
				Mockito.verifyNoMoreInteractions(mockedLogger);
			}
		}
	}
}

