package dk.sosi.sts.monitor;

import org.junit.Test;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import static dk.sosi.sts.server.util.HttpUtil.httpGet;
import static org.junit.Assert.*;

public class StatusCheckIT {
    private final URI stsStatusCheckEndpoint, stsStatusEndpoint, stsAlarmEndpoint;

    public StatusCheckIT() throws URISyntaxException {
        String host = System.getProperty("sts.url", "http://localhost:9090") + "/sts/";
        stsStatusCheckEndpoint = new URI(host + "checkstatus");
        stsStatusEndpoint = new URI(host + "status");
        stsAlarmEndpoint = new URI(host + "alarm");
    }

    @Test
    public void givenStsWhenStatusCheckIcCalledThenResponseShouldBeOk() throws IOException {
        assertEquals(200, httpGet(stsStatusCheckEndpoint).getStatusCode());
    }

    @Test
    public void givenStsWhenStatusIcCalledThenResponseShouldBeOk() throws IOException {
        assertEquals(200, httpGet(stsStatusEndpoint).getStatusCode());
    }

    @Test
    public void givenStsWhenAlarmIcCalledThenResponseShouldBeOk() throws IOException {
        assertEquals(200, httpGet(stsAlarmEndpoint).getStatusCode());
    }
}