package dk.sosi.sts.server;

import java.security.cert.X509Certificate;
import java.util.Properties;

import org.w3c.dom.Document;

import dk.sosi.seal.model.OIOSAMLAssertion;
import dk.sosi.seal.pki.OCESTestHelper;
import dk.sosi.seal.pki.PKITestCA;
import dk.sosi.seal.util.SOSITestUtils;
import dk.sosi.seal.vault.renewal.KeyGenerator;
import dk.sosi.seal.xml.XmlUtil;

/**
 * User: ksr
 * Date: 21-10-14
 * Time: 14:26
 */
public class SealTestHelper {

    public static X509Certificate issueCertificate() throws Exception {
        Properties properties = System.getProperties();
        KeyGenerator kg = new KeyGenerator("1", properties);
        kg.setKeySize(512);
        kg.generateKeyPair();

        PKITestCA ca = new PKITestCA();
        return OCESTestHelper.issueCertificate("cn=TestCert,o=Test,c=DK", null, kg.getPublicKey(), ca.getRootCertificate().getPublicKey());
    }

    public static OIOSAMLAssertion parseOIOSAMLAssertion(final String clPath) {
        String xml = SOSITestUtils.readXMLStreamAndRemoveFormatting(SealTestHelper.class.getResourceAsStream(clPath));
        Document document = XmlUtil.readXml(System.getProperties(), xml, false);
        return new OIOSAMLAssertion(document.getDocumentElement());
    }

}
