package dk.sosi.sts.server.facade;

import dk.sosi.seal.pki.CertificateInfo;
import dk.sosi.seal.vault.CredentialVault;
import dk.sosi.seal.vault.GenericCredentialVault;
import dk.sosi.sts.certificate.OcesInfo.Version;
import dk.sosi.sts.model.CprNr;

/**
 * Created by Kent on 20-03-2017.
 */
public interface SamlTokenTestModel {
	// contains the public/private key for the trusted vault
	// the same as the new-nemlogin as used in test environments
	// the "server" should be configured to trust this
	CredentialVault getExternalTrustedIdp();

	CredentialVault getAllTrustedCertificates();

	// a valid client vault
	// the relevant audiences should be configured to accept this
	GenericCredentialVault getValidWhitelistedVault();

	CprNr getPatientCpr();

	CertificateInfo getPatientCertificateInfo();

	String getClearTextAudience();

	String getClearTextAudienceNoWardWhitelisting();

	String getCryptAudience();

	String getSBOAudience();

	String getSBOAudience(boolean includeBst);

	String getBlurringAudience();
	
	Version getVersion();
}
