package dk.sosi.sts.server.test;

import dk.sosi.seal.vault.GenericCredentialVault;
import dk.sosi.sts.server.test.SealPPCredentialVaults.SealPPCredentialVaultProvider;

public class SealPPOces2CredentialVaultProvider implements SealPPCredentialVaultProvider {
	private static final String password = "Test1234";

	@Override
	public GenericCredentialVault getCredentialVault(Key key) {
		switch (key) {
			case VALID_MOCES_NO_CPR :
				return TestUtil.getVaultFromResource("oces2/PP/MOCES_gyldig.p12", password);
			case VALID_MOCES_WITH_CPR :
				return TestUtil.getVaultFromResource("oces2/PP/MOCES_cpr_gyldig.p12", password);
			case EXPIRED_MOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/MOCES_udloebet.p12", password);
			case REVOKED_MOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/MOCES_spaerret.p12", password);
			case VALID_VOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/VOCES_gyldig.p12", password);
			case EXPIRED_VOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/VOCES_udloebet.p12", password);
			case REVOKED_VOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/VOCES_spaerret.p12", password);
			case VALID_FOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/FOCES_gyldig.p12", password);
			case EXPIRED_FOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/FOCES_udloebet.p12", password);
			case REVOKED_FOCES_VAULT :
				return TestUtil.getVaultFromResource("oces2/PP/FOCES_spaerret.p12", password);
			default :
				throw new RuntimeException(key + " er ikke implementeret i " + getClass().getName());
		}

	}

}
